Added "path" ability to -n option to enable ripping from a DVD folder location
[rip_dvd/.git] / rip_dvd
1 #!/bin/bash
2 #
3 # Author: Alan J. Pippin (apippin@pippins.net)
4 # Date: 05/17/2009
5 #
6   REV=1.0
7 #
8 # Description: This script wraps a number of linux utilities to
9 # create a recipe for ripping protected DVDs, circumventing 
10 # ARcoSS and CRC checksum error protection schemes used on many
11 # newer DVDs. Edit as appropriate for your needs. I use this to
12 # backup DVDs I own, and do not condone any other activity it
13 # may be used for.
14 #
15 # Known Issues/Limitations:
16 # - Mirror mode is always done in ISO mode
17 #
18 # Package Dependencies:
19 # lsdvd dvdauthor gddrescue dvdbackup makexml tovid mencoder vlc mplayer genisoimage
20 #
21 # Optional Dependencies:
22 # lookup imdb info/posters for mythvideo: http://www.mythtv.org/wiki/Fill_mythvideo_metadata.pl
23 #
24
25 ###############################################
26 # Local Machine Settings - EDIT THIS SECTION
27
28 # Specify the device path to the DVD drive
29 dev=/dev/dvd2
30
31 # Specify the path to the log directory 
32 logdir=/var/log/ripdvd
33
34 # Specify the path to the tmp rip directory
35 tmpdir=/myth/video/DVDs/.ripdvd
36
37 # Specify the email address to send job notifications to
38 mailto=ajp@pippins.net
39
40 # Setup the path to the tools needed by this ripper
41 PATH=/etc/mythtv/bin:/usr/local/bin:/usr/sbin:/sbin:/usr/bin:.:$PATH
42
43 # Use mplayer dumpstream to create the main VOB file
44 # If set to 0, cat and other utils will be used to make it instead.
45 # Using mplayer dumpstream is by far the best way to create the main VOB file
46 # The only thing this doesn't work for are DVDs with the 99 title copy protection.
47 # The script will autodetect these types of disks, and change this to 0 if necessary.
48 # If this is set to 0, other methods will be employed to get the DVD VOB dump.
49 use_mplayer_dumpstream=1
50
51 # 2-channel AVI encoding audio bit rate
52 audio_bitrate=224
53
54 # If set to 1, this script will call another script to fill in the mythvideo metadata
55 # If you don't use mythtv, set this option to 0. If you use mythtv, and have downloaded
56 # the fill_mythvideo_metadata.pl script shown above, you can leave this option set to 1.
57 fill_mythvideo_metadata=1
58
59 # If the 99 titleset copy protection scheme is detected, trust the autodetection or abort.
60 # The autodetection may work, but it probably won't in this case. Set to 0 by default. 
61 # Override to 1 if you want the script to wing it, and hope it picks the right feature title.
62 trust_feature_title_autodetect_when_uncertain=0
63
64 ###############################################
65 # Command line processing
66 typeset dvdname=""
67 typeset debug=""
68 typeset dest=""
69 typeset isofile=""
70 typeset dvdpath=""
71 typeset -i keep_intermediate_files=0
72 typeset -i make_final_dest_vob=0
73 typeset -i make_final_dest_iso=0
74 typeset -i make_final_dest_folder=0
75 typeset -i make_final_dest_avi=0
76 typeset -i errors=0
77 typeset -i show_usage=0
78 typeset -i mirror_mode=0
79 typeset -i target_bitrate=0
80 typeset -i target_size=0
81 typeset -i audio_2ch=0
82 typeset -i invalid_feature_title=0
83 typeset -i feature_title_override=0
84 typeset -i mplayer_dumpstream_incompatibility=0
85
86 while (($#)) && getopts 2mvifkxht:n:d:b:s:t: opt "$@"
87 do
88     case $opt in
89         (n)     dvdname=$OPTARG;;
90         (d)     dest=$OPTARG;;
91         (b)     target_bitrate=$OPTARG;;
92         (s)     target_size=$OPTARG;;
93         (2)     audio_2ch=1;;
94         (v)     make_final_dest_vob=1;;
95         (i)     make_final_dest_iso=1;;
96         (f)     make_final_dest_folder=1;; 
97         (x)     make_final_dest_avi=1;;
98         (m)     mirror_mode=1;;
99         (k)     keep_intermediate_files=1;;
100         (t)     feature_title_override=$OPTARG;;
101         (w)     set -$opt;;
102         (h)     show_usage=1;;
103         (:)     echo >&2 "$0: $OPTARG requires a value"; errors=errors+1;;
104         (\?)    echo >&2 "$0: invalid option '$OPTARG'"; errors=errors+1;;
105     esac
106 done
107
108 shift $((OPTIND-1))
109
110 function usage() {
111     echo >&2 "Usage: ${0##*/} -d <destdir> [ <options> ]"
112     echo >&2 "Revision $REV"
113     echo >&2 "Options:"
114     echo >&2 "   -d <destdir>  Specify the destination directory to store the ripped DVD to"
115     echo >&2 "   -n <dvdname>  Specify what the name of the DVD is to process from $tmpdir"
116     echo >&2 "                 If it is a full path to a DVD folder, it will be ripped instead of $dev"
117     echo >&2 "                 This is optional. If not specified, the dvd will be pulled from $dev"
118     echo >&2 "   -m            Make a mirror image of the DVD and save it as a DVD ISO file"
119     echo >&2 "                 The default operation is non-mirror mode where only the main"
120     echo >&2 "                 feature title will be ripped."
121     echo >&2 "   -v            Make the final image a DVD VOB file"
122     echo >&2 "   -i            Make the final image a DVD ISO file"
123     echo >&2 "   -f            Make the final image a DVD folder"
124     echo >&2 "   -x            Make the final image an AVI (XVID) file"
125     echo >&2 "                 You must also specify the target size or bitrate using the '-s' or '-b' options"
126     echo >&2 "   -s <size>     Set the target size of the AVI file in MB (ex: 700, 1000, etc)"
127     echo >&2 "   -b <bitrate>  Set the bitrate desired in the AVI file in kbits/sec (ex: 1500, 2000 (default), etc)"    
128     echo >&2 "   -2            Use 2 channel MP3 audio encoding when making an AVI file (default is 6 channel AC3)"
129     echo >&2 "   -k            Keep the intermediate files (good for debugging)"
130     echo >&2 "                 In -x mode, run with this option to keep the original .VOB file"
131     echo >&2 "                 By default, all intermediary files are deleted. Only the final image is kept"
132     echo >&2 "   -t <title>    Specify the main feature title to pull from the DVD (only required if this script can't figure it out)"
133     echo >&2 "   -w            Set the sh Execute/Verbose flag"
134     echo >&2 ""
135     exit 2
136 }
137
138 if (($errors)) || (($show_usage))
139 then
140   usage
141 fi
142
143 # Sanity Check - Command Line Options 
144 if [ "$dest" == "" ]; then
145   echo "-E- You must specify a destination directory with '-d'" | tee -a $logfile
146   usage
147 fi
148
149 if ([ $target_bitrate -ne 0 ] || [ $target_size -ne 0 ]) && [ $make_final_dest_avi -ne 1 ]; then
150   echo "-E- You can't specify a bitrate in non AVI file mode. You must specify '-x' when using '-b' or '-s'" | tee -a $logfile
151   usage
152 fi
153
154 if [ $target_bitrate -eq 0 ] && [ $target_size -eq 0 ] && [ $make_final_dest_avi -eq 1 ]; then
155   echo "-E- You must specify a bitrate in AVI file mode. You must specify '-b' or '-s' when using '-x'" | tee -a $logfile
156   usage
157 fi
158
159 if [ $make_final_dest_vob -eq 0 ] && [ $make_final_dest_iso -eq 0 ] && 
160    [ $make_final_dest_folder -eq 0 ] && [ $make_final_dest_avi -eq 0 ] && [ $mirror_mode -eq 0 ]; then
161   echo "-E- You must specify what type of final destination you want: '-m' or '-v' or '-i' or '-f' or '-x'" | tee -a $logfile
162   usage
163 fi
164
165 if [ $mirror_mode -eq 1 ]; then
166   if [ $make_final_dest_vob -eq 1 ] || [ $make_final_dest_iso -eq 1 ] || 
167      [ $make_final_dest_folder -eq 1 ] || [ $make_final_dest_avi -eq 1 ]; then
168     echo "-E- You can't specify '-v' or '-i' or '-f' or '-x' when operating in mirror mode with '-m'" | tee -a $logfile
169     usage
170   fi
171 fi
172
173 # Sanity Check - Key executables
174 [[ ! -x `which lsdvd` ]] && echo "-E- missing dependency: lsdvd" && exit
175 [[ ! -x `which volname` ]] && echo "-E- missing dependency: volname" && exit
176 [[ ! -x `which ddrescue` ]] && echo "-E- missing dependency: ddrescue" && exit
177 [[ ! -x `which dvdbackup` ]] && echo "-E- missing dependency: dvdbackup" && exit
178 [[ ! -x `which mencoder` ]] && echo "-E- missing dependency: mencoder" && exit
179 [[ ! -x `which makexml` ]] && echo "-E- missing dependency: makexml" && exit
180 [[ ! -x `which dvdauthor` ]] && echo "-E- missing dependency: dvdauthor" && exit
181 [[ ! -x `which mkisofs` ]] && echo "-E- missing dependency: mkisofs" && exit
182
183 ###############################################
184
185 typeset -i ripdvd
186 if [ -z "$dvdname" ]; then
187   # make sure the DVD device is accessible
188   volname $dev > /dev/null 2>&1
189   if [ $? != 0 ]; then
190     echo "-E- Can't access the DVD device $dev"
191     exit 1
192   fi
193   # now capture the volume name from the device
194   dvdname=`volname $dev | awk '{ print $1 }'`
195   ripdvd=1
196 else 
197   # check to see if dvdname is a full path to a real directory
198   # if it is, set dvdname and dvdpath appropriately
199   if [ -d "$dvdname" ]; then
200     dvdpath="$dvdname"
201     dvdname=`basename "$dvdname"`
202     if [ -z "$dvdname" ]; then
203      fatal_and_exit "-E- Unable to extract dvdname from path: $dvdpath"
204     fi
205     if [ ! -d "$dvdpath/VIDEO_TS" ]; then
206       fatal_and_exit "-E- You must supply a full path to a valid DVD folder with this option"
207     fi
208   fi
209   ripdvd=0
210 fi
211
212 # Make sure we have a non-empty dvdname
213 if [ -z "$dvdname" ]; then
214   echo "-E- unable to determine dvdname"
215   exit 1
216 fi
217
218 # set up some variables to hold various logfiles
219 logfile="$logdir/$dvdname.log"
220 passlogfile="$tmpdir/divx2pass.log"
221 ddrescuelog=`tempfile`
222 dvdauthorlog=`tempfile`
223 encodelog=`tempfile`
224 dumplog=`tempfile`
225
226 # create the tmpdir if it doesn't already exist
227 if [ ! -d "$tmpdir" ]; then
228   mkdir -p "$tmpdir"
229   if [ $? != 0 ]; then
230     echo "-E- Unable to create the tmpdir: $tmpdir"
231     exit 1
232   fi
233 fi
234
235 # create the logdir if it doesn't already exist
236 if [ ! -d "$logdir" ]; then
237   mkdir -p "$logdir"
238   if [ $? != 0 ]; then
239     echo "-E- Unable to create the logdir: $logdir"
240     exit 1
241   fi
242 fi
243
244 ###############################################
245 # cleanup functions
246 cleanup() { 
247   if [ $keep_intermediate_files -eq 0 ]; then
248     [[ -e "$dvdauthorlog" ]] && rm -f "$dvdauthorlog"
249     [[ -e "$ddrescuelog" ]] && rm -f "$ddrescuelog"
250     [[ -e "$encodelog" ]] && rm -f "$encodelog"
251     [[ -e "$dumplog" ]] && rm -f "$dumplog"
252   else
253     [[ -e "$dvdauthorlog" ]] && echo "-> Keeping dvdauthor log: $dvdauthorlog" | tee -a "$logfile"
254     [[ -e "$ddrescuelog" ]] && echo "-> Keeping ddrescue log: $ddrescuelog" | tee -a "$logfile"
255     [[ -e "$encodelog" ]] && echo "-> Keeping encode log: $encodelog" | tee -a "$logfile"
256     [[ -e "$dumplog" ]] && echo "-> Keeping dump log: $dumplog" | tee -a "$logfile"
257   fi
258   echo ""
259 }
260
261 fatal_and_exit() {
262   if [[ -z "$1" ]]; then
263     msg="-E- control-c killed us"
264   else
265     msg=$1
266   fi
267   echo -e 2>&1 "$msg" | tee -a "$logfile"
268   if [[ -n "$mailto" ]]; then
269     echo -e "$msg" | mailx -s "dvd rip of $dvdname FAILED" "$mailto"
270   fi
271   exit 1
272 }
273
274 # Call our cleanup functions on INT and EXIT signals
275 trap fatal_and_exit INT
276 trap cleanup EXIT
277
278 ###############################################
279 # processing functions
280 function make_dvd_iso_image {
281
282   isofile="$1"
283
284   # check to see if we have a dvdpath to rip from instead of $dev
285   if [ -z "$dvdpath" ]; then
286     # load the CSS codes in the DVD drive 
287     lsdvd $dev >> "$logfile"
288     if [ $? != 0 ]; then
289       fatal_and_exit "-E- lsdvd $dev failed" 
290     fi
291
292     # read the DVD, ignoring/skipping CRC errors
293     ddrescue -n -b 2048 $dev "$isofile" "$ddrescuelog"
294     if [ $? != 0 ]; then
295       fatal_and_exit "-E- ddrescue -n -b 2048 $dev \"$isofile\" failed"
296     fi
297     cat "$ddrescuelog" >> "$logfile"
298   else
299     # rip from a path instead
300     make_dvd_iso_image_from_folder "$dvdpath" "$isofile"
301     if [ ! -s "$isofile" ]; then
302       fatal_and_exit "-E- Unable to make an iso image from the DVD folder: $dvdpath"
303     fi
304   fi
305 }
306
307 function make_dvd_iso_image_from_folder {
308   
309   src="$1"
310   dst="$2"
311   
312   echo "-> Creating ISO image of DVD video: $src -> $dst" | tee -a "$logfile"
313
314   # make an iso image out of our directory
315   echo "   mkisofs -dvd-video \"$src\" 2>> \"$dumplog\" | dd of=\"$dst\" obs=32k seek=0 > /dev/null 2>> $dumplog" >> "$logfile"
316   mkisofs -dvd-video "$src" 2>> "$dumplog" | dd of="$dst" obs=32k seek=0 > /dev/null 2>> "$dumplog"
317   if [ $? != 0 ]; then
318     fatal_and_exit '-E- mkisofs -dvd-video "$src" | dd of="$dst" obs=32k seek=0 failed'
319   fi
320 }
321
322 function make_dvdbackup_folder_image {
323   # extract the feature title from the DVD image
324   echo "-> Extracting feature title using dvdbackup" | tee -a "$logfile"
325   [[ -d "$tmpdir/$dvdname" ]] && rm -rf "$tmpdir/$dvdname"
326   dvdbackup -F -i "$isofile" -o "$tmpdir" >> "$logfile"
327   if [ $? != 0 ]; then
328     fatal_and_exit '-E- dvdbackup -F -i "$isofile" -o "$tmpdir" failed'
329   fi
330 }
331
332 function make_dvdauthor_folder_image {
333   # create a new DVD video of the feature title
334   echo "-> Creating DVD video $dest/$dvdname" | tee -a "$logfile"
335   [[ -d "$dest/$dvdname" ]] && rm -rf "$dest/$dvdname"
336   dvdauthor -o "$dest/$dvdname" -x dvd.xml > $dvdauthorlog 2>&1
337   cat $dvdauthorlog | grep -v "VOBU" >> "$logfile"
338
339   # There is a chance that dvdauthor won't like some of the VOBs.
340   # We can't tell ahead of time which ones it will choke on. 
341   # So, we need to run it over and over again until it can process
342   # all the VOBs. If it can't handle one of them, run it through
343   # mencoder to fix it and try again. These errors are typically
344   # present due to the copy protection that ddrescue removed.
345   grep -q "SCR moves" $dvdauthorlog
346   while [ $? == 0 ]; do
347     # fix bad vobs that get the "SCR moves backwards" error:
348     #  STAT: Processing VTS_01_0.VOB...
349     #  ERR:  SCR moves backwards, remultiplex input.
350     badvob=`grep -v "^WARN:" $dvdauthorlog | grep -B 1 "SCR moves" | grep "Processing" | awk '{ print $3 }' | sed -e 's/\.\.\.//'`
351     if [[ ! -f "$badvob" ]]; then
352       fatal_and_exit "-E- Found a bad VOB, but could not extract it's name properly: $badvob"
353     fi
354     echo "-> Fixing SCR errors in DVD video file $badvob" | tee -a "$logfile"
355     cat $badvob | mencoder $lang_opts -quiet -of mpeg -mpegopts format=dvd -oac copy -ovc copy - -o $badvob.fixed >> "$logfile" 2>&1
356     mv -f $badvob.fixed $badvob
357     echo "-> Creating DVD video $dest/$dvdname"
358     dvdauthor -o "$dest/$dvdname" -x dvd.xml > $dvdauthorlog 2>&1
359     cat $dvdauthorlog | grep -v "VOBU" >> "$logfile"
360     grep -q "SCR moves" $dvdauthorlog
361   done
362 }
363
364 function get_feature_title {
365   # if a feature title was given on the command line, use it
366   if [ $feature_title_override -ne 0 ]; then
367     feature_title=$feature_title_override
368     return 0
369   fi
370   # otherwise, use lsdvd to figure it out
371   if [ $ripdvd -eq 1 ]; then
372     feature_title=`lsdvd $dev | awk '/Longest/ { print $NF }'`
373   else 
374     feature_title=`lsdvd "$isofile" | awk '/Longest/ { print $NF }'`
375   fi
376 }
377
378 function create_main_vob_with_cat {
379   # cd to the feature title DVD folder
380   pushd "$tmpdir/$dvdname/VIDEO_TS" > /dev/null 2>&1
381   if [ $? != 0 ]; then
382     fatal_and_exit "-E- Unable to cd to $tmpdir/$dvdname/VIDEO_TS"
383   fi
384
385   # concatenate all the VOBs together into 1 giant VOB
386   vobs=`/bin/ls -1 VTS*.VOB | grep -v "0.VOB" | tr '\n' ' '`
387   cat $vobs > "$tmpdir/$dvdname.VOB"
388
389   # cd back to the dir we started from
390   popd > /dev/null 2>&1
391 }
392
393 function create_main_vob_with_mplayer {
394   # make sure we have a valid feature title
395   if [ $invalid_feature_title -eq 1 ] && [ $feature_title_override -eq 0 ]; then
396     fatal_and_exit "-E- You must have a valid feature title to get the VOB via mplayer dumpstream. We can't determine the feature title for this DVD."
397   fi
398
399   # check to make sure we didn't detect an mplayer dumpstream incompatibility earlier
400   if [ $mplayer_dumpstream_incompatibility -eq 1 ]; then
401     msg="-E- We detected an mplayer dumpstream incompatibility earlier."
402     msg="$msg We also detected another condition that requires us to use dumpstream. "
403     msg="$msg\n    Unable to rip this DVD in the mode you requested."
404     fatal_and_exit "$msg"
405   fi
406
407   # use mplayer to create the main VOB file
408   remove_dumplog=$1
409   echo "-> Using mplayer to dump the DVD feature title $feature_title to a VOB file directly: $dest/$dvdname.VOB" | tee -a "$logfile"
410   echo "   mplayer $lang_opts -dumpstream -dumpfile \"$dest/$dvdname.VOB\" -dvd-device \"$isofile\" dvd://$feature_title > $dumplog 2>&1" >> "$logfile"
411   mplayer $lang_opts -dumpstream -dumpfile "$dest/$dvdname.VOB" -dvd-device "$isofile" dvd://$feature_title > $dumplog 2>&1
412   if [ $? != 0 ]; then
413     cat $dumplog | grep -v "^A:" >> "$logfile"
414     fatal_and_exit "-E- Mplayer Failed"
415   fi
416   cat $dumplog | grep -v "^A:" >> "$logfile"
417   [[ -e "$dumplog" ]] && [[ $remove_dumplog -eq 1 ]] && rm -f $dumplog
418 }
419
420 function get_audio_id_from_iso {
421   # Adjust our audio ID to find the english audio stream
422   # This should be 128. However, if 128 is not there, pick the next one that incrementally is.
423   aidcheck=`tempfile`
424   aid=128
425   mplayer -v -endpos 0 -dvd-device "$isofile" dvd://$feature_title > $aidcheck 2>&1
426   grep -q "aid: $aid" $aidcheck
427   while [ $? == 1 ] && [ $aid -lt 159 ]; do
428     (( aid = aid + 1 ))
429     grep -q "aid: $aid" $aidcheck
430   done
431   [[ -e "$aidcheck" ]] && rm -f "$aidcheck"
432   echo "-> Setting the audio stream ID to $aid" | tee -a "$logfile"
433   # mencoder default DVD audio track language selection (english)
434   lang_opts="-aid $aid -alang en"
435 }
436
437 function get_crop_from_iso { 
438   FRAMES=10000
439   echo "-> Detecting black frame border crop value from ISO file"
440   echo "   mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark -dvd-device \"$isofile\" dvd://$feature_title > $dumplog 2>&1" >> "$logfile"
441   mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark -dvd-device "$isofile" dvd://$feature_title > $dumplog 2>&1
442   [[ -e "md5sums" ]] && rm -f "md5sums"
443   CROP=`cat $dumplog | grep CROP | tail -1`
444   echo "   Found crop value of $CROP" >> "$logfile"
445   CROP=${CROP#* crop=}
446   CROP=${CROP%%\).*}
447   typeset -i CROPCHECK
448   CROPCHECK=`echo "$CROP" | awk -F ':' '{ print $1 }'`
449   echo "   Final crop value of $CROP with cropcheck value of $CROPCHECK" >> "$logfile"
450   if [ -z "$CROP" ]; then
451     fatal_and_exit "-E- Unable to extract CROP value from iso: $isofile"
452   fi
453   if [ $CROPCHECK -lt 0 ]; then 
454     CROP=""
455   else 
456     CROP=",crop=$CROP"
457   fi
458   echo "   Setting mencoder crop filter to: $CROP"
459 }
460
461 function get_audio_id_from_vob {
462   # Adjust our audio ID to find the english audio stream
463   # This should be 128. However, if 128 is not there, pick the next one that incrementally is.
464   aidcheck=`tempfile`
465   aid=128
466   mplayer -v -endpos 0 "$tmpdir/$dvdname.VOB" > $aidcheck 2>&1
467   grep -q "Found audio stream: $aid" $aidcheck
468   while [ $? == 1 ] && [ $aid -lt 159 ]; do
469     (( aid = aid + 1 ))
470     grep -q "Found audio stream: $aid" $aidcheck
471   done
472   [[ -e "$aidcheck" ]] && rm -f "$aidcheck"
473   echo "-> Setting the audio stream ID to $aid" | tee -a "$logfile"
474   # mencoder default DVD audio track language selection (english)
475   lang_opts="-aid $aid -alang en"
476 }
477
478 function check_vob_for_corrupted_start {
479   # check to see if the beginning of the DVD has a form of copy protection
480   # where they have deliberately broken the first X number of frames of the DVD.
481   # If we don't skip these, our resulting VOB file will not play.
482   badvobcheck=`tempfile`
483   endpos=360
484   skip=0
485   mencoder -ss $skip -endpos $endpos $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy "$tmpdir/$dvdname.VOB" -o /dev/null > $badvobcheck 2>&1
486   if [ $? != 0 ]; then
487     fatal_and_exit "-E- Mencoder Failed"
488   fi
489   grep "Writing header" -A `wc $badvobcheck | awk '{ print $1 }'` $badvobcheck | grep -q "Too many video packets in the buffer"
490   while [ $? == 0 ] && [ $skip -lt $endpos ]; do
491     (( skip = skip + 5 ))
492     echo "-> Bad VOB copy protection detected. Trying new skip value of $skip" | tee -a "$logfile"
493     mencoder -ss $skip -endpos $endpos $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy "$tmpdir/$dvdname.VOB" -o /dev/null > $badvobcheck 2>&1
494     if [ $? != 0 ]; then
495       fatal_and_exit "-E- Mencoder Failed"
496     fi
497     grep "Writing header" -A `wc $badvobcheck | awk '{ print $1 }'` $badvobcheck | grep -q "Too many video packets in the buffer"
498   done
499   [[ -e "$badvobcheck" ]] && rm -f "$badvobcheck";
500
501   # cat the giant VOB into mencoder to create a playable VOB file
502   cat "$tmpdir/$dvdname.VOB" | mencoder -ss $skip -quiet $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy - -o "$dest/$dvdname.VOB" >> "$logfile" 2>&1
503   if [ $? != 0 ]; then
504     fatal_and_exit "-E- Mencoder Failed"
505   fi
506 }
507
508 function check_vob_for_completeness {
509   # check to make sure we got out a complete VOB.
510   # there is another kind of copy protection where the VOB's may
511   # have "MPG EOF" frames in the middle of the stream. 
512   # this causes mencoder to not process the entire VOB, and exit without any errors.
513   # detect this by seeing how much smaller the dst vob is from the src vob.
514   MAX_FILESIZE_DELTA_PERCENT=70
515   SRC_VOB_FILESIZE=$(stat -c%s "$tmpdir/$dvdname.VOB")
516   DST_VOB_FILESIZE=$(stat -c%s "$dest/$dvdname.VOB")
517   FILESIZE_DELTA=`echo "scale=2; $DST_VOB_FILESIZE / $SRC_VOB_FILESIZE * 100" | bc | awk -F '.' '{ print $1 }'`
518   if [ $FILESIZE_DELTA -lt $MAX_FILESIZE_DELTA_PERCENT ]; then
519     # Try one other way to get the VOB using mplayer directly to rip the feature titleset.
520     echo "-> Detected bad VOB size copy protection after processing concatenated VOB file." | tee -a "$logfile"
521     create_main_vob_with_mplayer
522     [[ -e "$dumplog" ]] && rm -f $dumplog
523     DST_VOB_FILESIZE=$(stat -c%s "$dest/$dvdname.VOB")
524     FILESIZE_DELTA=`echo "scale=2; $DST_VOB_FILESIZE / $SRC_VOB_FILESIZE * 100" | bc | awk -F '.' '{ print $1 }'`
525     if [ $FILESIZE_DELTA -lt $MAX_FILESIZE_DELTA_PERCENT ]; then
526       fatal_and_exit "-E- This DVD has a copy protection scheme we can't work around. Sorry.\n    I recommend using another ripping mode like '-m' or '-i'"
527     fi
528   fi
529 }
530
531 function check_vob_for_too_many_video_packets {
532   # If our earlier algorithm to work around this failed, throw an error.
533   # check to see if this DVD has a protection scheme we don't know how to work around
534   # when I tried to burn the CARS DVD for example, you can't play the resulting VOB file.
535   # for some reason, the video is black, while the audio rolls, then the video finally comes
536   # in, but it is WAY off the audio. This appears to be due to some bad frames at the beginning of 
537   # the 1st VOB. Until I figure out how to work around this, detect it, and error out.
538   # instead of pulling the image from the disk again, you can pull it directly from the iso: -dvd-device $iso_path
539   grep -q "Too many video packets in the buffer:" "$logfile"
540   if [ $? == 0 ]; then
541     # Try one other way to get the VOB using mplayer directly to rip the feature titleset.
542     echo "-> Detected corrupt audio stream copy protection after processing concatenated VOB file." | tee -a "$logfile"
543     create_main_vob_with_mplayer
544     grep -q "Too many video packets in the buffer:" $dumplog
545     if [ $? == 0 ]; then
546       [[ -e "$dumplog" ]] && rm -f $dumplog
547       fatal_and_exit "-E- This DVD has a copy protection scheme we can't work around. Sorry.\n   I recommend using another ripping mode like '-m' or '-i'"
548     fi
549     [[ -e "$dumplog" ]] && rm -f $dumplog
550   fi
551 }
552
553 function check_vob_for_a52_crc_errors {
554   # Let's see if we can playback our newly created VOB file without any errors.
555   # if there are issues, let's detect them now, and try to recreate the VOB
556   # there are some forms of copy protection that have missed above, that evidence
557   # themselves when we try to playback the VOB file. This was added to deal with
558   # the "a52: CRC check failed" copy protection scheme.
559   MAX_ERRORS=10
560   ENDPOS=120
561   echo "-> Checking for a52 audio stream CRC errors" | tee -a "$logfile"
562   mplayer -endpos $ENDPOS -ao null -vo null "$dest/$dvdname.VOB" > $dumplog 2>&1
563   cat $dumplog | grep -v "^A:" >> "$logfile"
564   errors=`grep "a52: CRC check failed" $dumplog | wc | awk '{ print $1 }'`
565   if [ $errors -gt $MAX_ERRORS ]; then
566     echo "-> Detected a52 audio stream CRC errors copy protection after processing concatenated VOB file." | tee -a "$logfile"
567     create_main_vob_with_mplayer
568     echo "-> Checking for a52 audio stream CRC errors" | tee -a "$logfile"
569     mplayer -endpos $ENDPOS -ao null -vo null "$dest/$dvdname.VOB" > $dumplog 2>&1
570     if [ $? != 0 ]; then
571       cat $dumplog | grep -v "^A:" >> "$logfile"
572       fatal_and_exit "-E- Mplayer Failed"
573     fi
574     cat $dumplog | grep -v "^A:" >> "$logfile"
575     errors=`grep "a52: CRC check failed" $dumplog | wc | awk '{ print $1 }'`
576     if [ $errors -gt $MAX_ERRORS ]; then
577       fatal_and_exit "-E- This DVD has a copy protection scheme we can't work around. Sorry.\n   I recommend using another ripping mode like '-m' or '-i'"
578     fi
579   fi
580   [[ -e "$dumplog" ]] && rm -f $dumplog
581 }
582
583 function calculate_bitrate_from_target_size {
584   # determine what our bitrate needs to be if a target size was specified instead
585   if [ $target_size -ne 0 ]; then
586     vob_length=`mplayer -identify -v "$dest/$dvdname.VOB" -endpos 0 2>&1 | grep ID_LENGTH | awk -F '=' '{ print $2 }' | awk -F '.' '{ print $1 }'`
587     ((target_bitrate = (target_size * 1024 * 8) / vob_length ))
588     echo "   With a given target size of $target_size MB, the estimated bit rate will need to be $target_bitrate kbits/sec"
589   fi
590 }
591
592 function create_dvdauthor_dvd_xml_file {
593   # make a dvdauthor xml menu file to create a valid DVD video from 
594   # this script does a good job, but we'll still need to clean it up a bit after it runs
595   echo "-> Creating dvdauthor XML menu file" | tee -a "$logfile"
596   makexml -overwrite -dvd *.VOB -out dvd >> "$logfile" 2>&1
597   if [ $? != 0 ]; then
598     fatal_and_exit '-E- makexml -dvd *.VOB -out dvd failed'
599   fi
600
601   # replace the first line of the xml file to remove the bad dest path
602   awk -v line=1 -v new_content="<dvdauthor>" '{
603     if (NR == line) {
604       print new_content;
605     } else {
606       print $0;
607     }
608   }' dvd.xml > dvd.xml.new
609   mv -f dvd.xml.new dvd.xml
610   if [ $? != 0 ]; then
611     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
612   fi
613
614   # remove the "<video " property line from the xml file
615   cat dvd.xml | grep -v "<video" > dvd.xml.new
616   mv -f dvd.xml.new dvd.xml
617   if [ $? != 0 ]; then
618     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
619   fi
620   
621   # remove the extra <pgc>..</pgc> pairs
622   cat dvd.xml | awk 'BEGIN {x=1}
623   {
624     if ($0~"</pgc>") {x=0}
625     if (x==1) {print $0}
626     if ($0~"<pgc>") {x=1}
627   }' > dvd.xml.new
628   echo -e "</pgc>\n</titles>\n</titleset>\n</dvdauthor>" >> dvd.xml.new
629   mv -f dvd.xml.new dvd.xml
630   if [ $? != 0 ]; then
631     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
632   fi
633
634   # remove the VTS_*_0.VOB file as this is just the main menu video clip
635   cat dvd.xml | grep -v "VTS_.*_0.VOB" > dvd.xml.new
636   mv -f dvd.xml.new dvd.xml
637   if [ $? != 0 ]; then
638     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
639   fi
640 }
641
642 function check_for_mplayer_dumpstream_incompatibility {
643
644   echo "-> Checking for mplayer dumpstream incompatibilities" | tee -a "$logfile"
645
646   if [ ! -e "$dest/$dvdname.VOB" ]; then
647     # mplayer dumpstream does not work on DVDs that obscure the feature title.
648     # A DVD that has 99 titles, where the longest title isn't the main feature
649     # breaks mplayer dumpstream. We have to fallback to using dvdbackup to figure
650     # out what the feature title is. This script will run through that flow if we
651     # set use_mplayer_dumpstream to 0. Check for this here.
652     if [ $ripdvd -eq 1 ]; then
653       lsdvd $dev | grep -q "Title: 99"
654     else
655       lsdvd "$isofile" | grep -q "Title: 99"
656     fi
657     # If we have 99 titles and a feature title wasn't given on the command line, switch modes.
658     if [ $? == 0 ] && [ $feature_title_override -eq 0 ]; then
659       if [ $trust_feature_title_autodetect_when_uncertain -eq 0 ]; then
660         echo "-E- Unable to determine the feature title due to the 99 title copy protection scheme" | tee -a "$logfile"
661         echo "    You will need to determine this yourself and rerun the script with the -t option" | tee -a "$logfile"
662         invalid_feature_title=1
663       else 
664         echo "    Falling back to non mplayer dumpstream methods to copy the DVD" | tee -a "$logfile"
665         echo "-W- We still may not be able to autodetect the right feature title" | tee -a "$logfile"
666         echo "    You may need to determine this yourself and rerun the script with the -t option" | tee -a "$logfile"
667         use_mplayer_dumpstream=0
668         invalid_feature_title=1
669       fi
670       return
671     fi
672   fi
673
674   # There is another form of protection that causes the mplayer dumpstream to fail. 
675   # This can be detected by telling mplayer to parse the VOB file by copying its audio
676   # video streams to a dummy output file (/dev/null). Do that here to check for that 
677   # problem before continuing.
678   if [ -e "$dest/$dvdname.VOB" ]; then
679     mplayer_opts="-quiet -ofps 30000/1001 -ffourcc DIVX -oac copy -ovc copy"
680     mencoder $mplayer_opts "$dest/$dvdname.VOB" -o "/dev/null" > $dumplog 2>&1
681     grep -q "Too many audio packets in the buffer" $dumplog
682     if [ $? == 0 ]; then
683       echo "-> The VOB dumped by mplayer is invalid. Falling back to non mplayer dumpstream to copy the DVD" | tee -a "$logfile"
684       use_mplayer_dumpstream=0
685       mplayer_dumpstream_incompatibility=1
686     fi
687     [[ -e "$dumplog" ]] && rm -f $dumplog
688   fi
689 }
690
691 function fill_mythvideo_metadata {
692
693   # This function must be passed the filename as an argument
694   # The filename must be a full path to the file
695   filename="$1"
696
697   # Make sure the fill mythvideo metadata option has been set to 1
698   if [ $fill_mythvideo_metadata -eq 0 ]; then
699     echo "-> fill_mythvideo_metadata=0 therefore not updating mythvideo metadata for this rip" | tee -a "$logfile"
700     return 0
701   fi
702
703   # If the fill mythvideo metadata script is present, run it
704   # fill_mythvideo_metadata.plThis will download the metadata for the DVD we ripped.
705   if [[ -x `which fill_mythvideo_metadata.pl` ]]; then
706     echo "-> Running fill_mythvideo_metadata.pl to lookup/add/update the metadata for this DVD: $filename" | tee -a "$logfile"
707     fill_mythvideo_metadata.pl -N 0 -F "$filename" >> "$logfile" 2>&1
708   else
709     echo "-W- Unable to find the fill_mythvideo_metadata.pl script in your PATH. Unable to autofill the mythvideo DB for this rip." | tee -a "$logfile"
710     echo "    Set the fill_mythvideo_metadata variable to 0 in the script to avoid running this step." | tee -a "$logfile"
711   fi
712 }
713
714 function remove_intermediate_vob_file {
715   # remove the intermediate VOB file
716   if [ $keep_intermediate_files -eq 0 ]; then
717     [[ -e "$tmpdir/$dvdname.VOB" ]] && rm -f "$tmpdir/$dvdname.VOB"
718   else
719     echo "-> Keeping intermediate concatenated VOB file: $tmpdir/$dvdname.VOB" | tee -a "$logfile"
720   fi
721 }
722
723 function remove_intermediate_iso_file {
724   # remove the original DVD image 
725   if [ $keep_intermediate_files -eq 0 ]; then
726     [[ -e "$isofile" ]] && rm "$isofile"
727   else
728     echo "-> Keeping ddrescue intermediate iso file: $isofile" | tee -a "$logfile"
729   fi
730 }
731
732 function remove_intermediate_dvdbackup_folder {
733   if [ $keep_intermediate_files -eq 0 ]; then
734     [[ -d "$tmpdir/$dvdname" ]] && rm -rf "$tmpdir/$dvdname"
735   else
736     echo "-> Keeping intermediate dvdbackup folder: $tmpdir/$dvdname" | tee -a "$logfile"
737   fi
738 }
739
740 ###############################################
741 # MAIN
742
743 # Make a note of when this DVD rip started
744 date=`date`
745 echo -e "\n$date DVD rip started" >> "$logfile"
746
747 # Rip the DVD - Mirror Mode
748 if [ $mirror_mode -eq 1 ]; then
749   echo "-> Ripping DVD $dvdname to $dest"
750
751   # use ddrescue to make an ISO image of the disk
752   make_dvd_iso_image "$dest/$dvdname.iso"
753
754   # add this video data to the mythtv DB
755   fill_mythvideo_metadata "$dest/$dvdname.iso" 
756
757   # eject the disk upon completion
758   eject -T $dev
759
760   date=`date`
761   echo "$date DVD rip completed" | tee -a "$logfile"
762
763   if [[ -n "$mailto" ]]; then
764     cat "$logfile" | mailx -s "dvd rip of $dvdname DONE" "$mailto"
765   fi
766
767 fi
768
769 # Rip the DVD - Main Title Feature Only
770 if [ $mirror_mode -eq 0 ]; then
771
772   # Rip image from DVD
773   if [ $ripdvd -eq 1 ]; then
774     echo "-> Ripping DVD $dvdname to $dest" | tee -a "$logfile"
775     # use ddrescue to make an ISO image of the disk
776     make_dvd_iso_image "$tmpdir/$dvdname.iso"
777   fi
778
779   # Rip image from DVD path
780   if [ -n "$dvdpath" ]; then
781     echo "-> Ripping DVD $dvdpath to $dest" | tee -a "$logfile"
782     make_dvd_iso_image_from_folder "$dvdpath" "$tmpdir/$dvdname.iso"
783     if [ ! -s "$tmpdir/$dvdname.iso" ]; then
784       fatal_and_exit "-E- Unable to make an iso image from the DVD folder: $dvdpath"
785     fi
786   fi
787
788   # make sure our isofile value is set
789   if [ -z "$isofile" ]; then
790     isofile="$tmpdir/$dvdname.iso"
791   fi
792    
793   if [ $make_final_dest_vob -eq 1 ] || [ $make_final_dest_avi -eq 1 ]; then
794
795     if [ ! -e "$dest/$dvdname.VOB" ]; then
796       echo "-> Creating DVD video $dest/$dvdname.VOB" | tee -a "$logfile"
797       
798       # get the feature title from the ISO
799       get_feature_title
800  
801       # get the crop value from the ISO
802       get_crop_from_iso
803
804       # check for mplayer dumpstream incompatibilities
805       # if they exist, this method will set this mode to 0.
806       check_for_mplayer_dumpstream_incompatibility
807
808       if [ $use_mplayer_dumpstream -eq 1 ]; then 
809
810         # get our audio id from the ISO file
811         get_audio_id_from_iso
812
813         # create our main VOB file from the ISO
814         create_main_vob_with_mplayer        
815      
816         # remove the intermediate VOB file
817         remove_intermediate_vob_file
818
819         # it's possible that our VOB is still corrupted in some manner
820         # check to make sure it is still a good VOB before continuing.
821         check_for_mplayer_dumpstream_incompatibility
822
823       fi
824  
825       if [ $use_mplayer_dumpstream -eq 0 ]; then 
826
827         # use dvdbackup to make a DVD folder of the feature title
828         make_dvdbackup_folder_image
829   
830         # create our main VOB file
831         create_main_vob_with_cat
832
833         # get our audio id from the VOB file
834         get_audio_id_from_vob
835   
836         # check for corrupted VOB start
837         check_vob_for_corrupted_start
838  
839         # check to make sure our VOB is complete
840         check_vob_for_completeness
841
842         # check to make sure our VOB doesn't have too many video packets
843         check_vob_for_too_many_video_packets
844
845         # check to make sure our VOB doesn't have a52 crc errors
846         check_vob_for_a52_crc_errors
847
848         # remove the intermediate VOB file
849         remove_intermediate_vob_file
850
851       fi
852
853       # remove the intermediate ISO file
854       remove_intermediate_iso_file
855
856     else
857       echo "-> Skipping VOB creation. VOB DVD video already exists: $dest/$dvdname.VOB" | tee -a "$logfile"
858     fi
859
860     # transcode the DVD
861     if [ $make_final_dest_avi -eq 1 ]; then
862       echo "-> Encoding the DVD video to an AVI file" | tee -a "$logfile"
863
864       # determine what our bitrate needs to be if a target size was specified instead
865       calculate_bitrate_from_target_size        
866       
867       # There was a lot of experimentation to arrive at these values
868       # These seem to work OK for me. If they don't work for you, feel
869       # free to adjust/change as needed.
870
871       # Edit these as needed to suite your needs
872       mencoder_general_opts="-quiet $lang_opts -passlogfile $passlogfile"
873       mencoder_output_opts="-ofps 30000/1001 -ffourcc DIVX"
874       mencoder_video_filter_opts="-vf pullup,softskip,hqdn3d=2:1:2$CROP"
875       mencoder_video_encoder_opts="-ovc xvid -xvidencopts pass=%PASS:chroma_opt:vhq=4:bvhq=1:quant_type=mpeg:bitrate=$target_bitrate:autoaspect:threads=2"
876
877       # There are a number of different ways to encode 6 channel audio.
878       # I've loaded 3 different ways into the mencoder_audioch_opts.
879       # It will cycle through them until it finds one that works. 
880       # You can change the order to suit your needs.
881       if [ $audio_2ch -eq 0 ]; then
882
883         # These options produce good 6 channel audio for the internal mythvideo player, but they can't play in Windows.
884         #mencoder_audio_opts="-oac lavc -lavcopts acodec=ac3"
885         #mencoder_audioch_opts[0]="-channels 6 -af channels=6:6:0:5:1:4:2:3:3:2:4:1:5:0"
886
887         # These options produce good 6 channel audio for linux and windows (except the internal mythvideo player)
888         # This option requires playback under linux with mplayer to be done with options: -channels 6 -ac hwac3,hwdts,mad 
889         mencoder_audio_opts="-oac copy"
890
891         # There are 3 different ways to specify 6 channel encoding. We'll try the other ones in order if one of them fails.
892         mencoder_audioch_opts[0]="-channels 6 -af channels=6"
893         mencoder_audioch_opts[1]="-af channels=6"
894         mencoder_audioch_opts[2]=""
895
896      else 
897         # These options produce good 2 channel audio for linux and windows (including the internal mythvideo player)
898         mencoder_audio_opts="-oac mp3lame -lameopts cbr:br=$audio_bitrate"
899         mencoder_audioch_opts[0]=""
900      fi
901
902       # Do not edit this line. $mencoder_video_encoder_opts must be last
903       mencoder_opts="$mencoder_general_opts $mencoder_output_opts $mencoder_audio_opts $mencoder_video_filter_opts $mencoder_video_encoder_opts"
904       mencoder_retval=0
905
906       for PASS in 1 2 
907       do 
908         # Set some options based on which pass we are in
909         mencoder_opts_for_pass=$(echo "$mencoder_opts" | sed "s,%PASS,$PASS,g")
910         [ $PASS -eq 1 ] && mencoder_opts_for_pass="$mencoder_opts_for_pass:turbo"
911         [ $PASS -eq 1 ] && output_file="/dev/null"
912         [ $PASS -eq 2 ] && output_file="$dest/$dvdname.avi"
913   
914         # It's possible that the audio channel encoding may not work. Cycle through all our different audioch_opts until we find one that works.
915         for CH_OPTS in "${mencoder_audioch_opts[@]}"; 
916         do
917           echo -e "   Encoding pass $PASS"
918           echo -e "\n   Encoding pass $PASS: mencoder $CH_OPTS $mencoder_opts_for_pass \"$dest/$dvdname.VOB\" -o \"$output_file\" >> $encodelog 2>&1" >> "$logfile"
919           mencoder $CH_OPTS $mencoder_opts_for_pass "$dest/$dvdname.VOB" -o "$output_file" > $encodelog 2>&1
920           mencoder_retval=$? 
921           grep -q "\[channels\] Invalid" $encodelog
922           if [ $? != 0 ]; then      
923             break;
924           else
925             echo -e "\n-W- Audio channel encoding error. Falling back to next audio channel encoding scheme." >> "$logfile"
926           fi
927         done
928         if [ $mencoder_retval != 0 ]; then
929           fatal_and_exit "-E- Unhandled mencoder error"
930         fi
931         # Concatenate the encode log to our main log file, greping out unwanted lines
932         cat $encodelog | grep -v "Pos:" >> "$logfile"
933       done
934
935       if [ $keep_intermediate_files -eq 0 ] && [ $make_final_dest_vob -eq 0 ]; then
936         [[ -e "$dest/$dvdname.VOB" ]] && rm -f "$dest/$dvdname.VOB";
937         [[ -e "$passlogfile" ]] && rm -f "$passlogfile";
938       else
939         echo "-> Keeping VOB file: $dest/$dvdname.VOB" | tee -a "$logfile"
940         echo "-> Keeping mencoder 2pass logfile: $passlogfile"
941       fi
942     fi
943
944   # add this video data to the mythtv DB
945   [ $make_final_dest_avi -eq 1 ] && fill_mythvideo_metadata "$dest/$dvdname.avi" 
946   [ $make_final_dest_vob -eq 1 ] && fill_mythvideo_metadata "$dest/$dvdname.VOB" 
947     
948   else
949
950   # use dvdbackup to make a DVD folder of the feature title
951   make_dvdbackup_folder_image
952
953   # cd to the feature title DVD folder
954   pushd "$tmpdir/$dvdname/VIDEO_TS" > /dev/null 2>&1
955   if [ $? != 0 ]; then
956     fatal_and_exit "-E- Unable to cd to $tmpdir/$dvdname/VIDEO_TS"
957   fi
958   
959   # create the dvd.xml file for dvdauthor
960   create_dvdauthor_dvd_xml_file  
961
962   # make the final DVD folder image
963   make_dvdauthor_folder_image
964
965   # add this video data to the mythtv DB
966   fill_mythvideo_metadata "$dest/$dvdname/VIDEO_TS" 
967  
968   # cd back to the dir we started from
969   popd > /dev/null 2>&1
970
971   if [ $make_final_dest_iso -eq 1 ]; then
972
973     # make an iso image out of our directory
974     make_dvd_iso_image_from_folder "$dest/$dvdname" "$dest/$dvdname.iso"
975    
976     # If the mkisofs was unable to make a .iso file for us, don't remove the DVD directory 
977     if [ -s "$dest/$dvdname.iso" ]; then
978       if [ $make_final_dest_folder -eq 0 ]; then
979         echo "-> Removing DVD folder since ISO was created: $dest/$dvdname" | tee -a "$logfile"
980         # remove the folder of the DVD image now that we have a .iso version of it
981         [[ -d "$dest/$dvdname" ]] && rm -rf "$dest/$dvdname"
982       fi
983     else
984       # we created an empty iso file, remove it
985       echo "-> Removing empty ISO image: $dest/$dvdname.iso" | tee -a "$logfile"
986       echo "-> Keeping the DVD folder since the ISO image couldn't be created properly: $dest/$dvdname"
987       [[ -e "$dest/$dvdname.iso" ]] && rm "$dest/$dvdname.iso"
988     fi
989  
990     # add this video data to the mythtv DB
991     fill_mythvideo_metadata "$dest/$dvdname.iso" 
992
993   fi
994
995   fi
996
997   # remove the ddrescue DVD ISO image
998   remove_intermediate_iso_file
999
1000   # remove the tmp dvdbackup folder of the DVD image
1001   remove_intermediate_dvdbackup_folder
1002
1003   # eject the DVD disk upon completion
1004   [ $ripdvd -eq 1 ] && eject -T $dev
1005
1006   date=`date`
1007   echo "$date DVD rip completed" | tee -a "$logfile"
1008
1009   if [[ -n "$mailto" ]]; then
1010     cat "$logfile" | mailx -s "dvd rip of $dvdname DONE" "$mailto"
1011   fi
1012
1013 fi
1014